﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SpaceShips
{
    public class Bullet
    {
        /// <summary>
        /// Pozice kulky
        /// </summary>
        public Vector2 position;
        /// <summary>
        /// Ohraničení kulky
        /// </summary>
        public Rectangle bulletRec;
        /// <summary>
        /// Rychlost kulky
        /// </summary>
        private int speed;

        /// <summary>
        /// Konstruktor
        /// </summary>
        /// <param name="position">Startovní pozice kulky</param>
        /// <param name="speed">Rychlost letu kulky</param>
        public Bullet(Vector2 position, int speed)
        {
            this.position = position;  // Startovní pozice kulky
            this.speed = speed;        // Rychlost letu kulky
        }

        /// <summary>
        /// Vykreslení kulky
        /// </summary>
        /// <param name="spriteBatch">Třída pro práci se sprity</param>
        /// <param name="startX">X-ová začínající pozice vzniku kulky</param>
        /// <param name="startY">Y-ová začínající pozice vzniku kulky</param>
        /// <param name="sprBullet">Sprit kulky</param>
        public void DrawBullet(SpriteBatch spriteBatch, int startX, int startY, Texture2D sprBullet)
        {
            spriteBatch.Draw(sprBullet, new Vector2(position.X + startX, position.Y - startY), Color.White);
        }

        /// <summary>
        /// Let kulky
        /// </summary>
        /// <param name="widthSpr">Šířka kulky</param>
        /// <param name="heightSpr">Výška kulky</param>
        /// <param name="speed">Rychlost a směr kulky</param>
        public void ControlBullet(int widthSpr, int heightSpr)
        {
            position.Y -= speed;   // Směr letu kulky
            bulletRec = new Rectangle((int)position.X, (int)position.Y, widthSpr, heightSpr);  // Ohraničení střely
        }
    }
}
