﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SpaceShips
{
    public class Enemy
    {
        /// <summary>
        /// Pozice nepřítele
        /// </summary>
        private Vector2 position;
        /// <summary>
        /// Rychlost
        /// </summary>
        private float speed;
        /// <summary>
        /// Ohraničení nepřítele
        /// </summary>
        public Rectangle enemyRec;

        /// <summary>
        /// Konstruktor
        /// </summary>
        /// <param name="position">Startovní pozice</param>
        /// <param name="speed">Rychlost</param>
        public Enemy(Vector2 position, float speed)
        {
            this.position = position;      // Startovní pozice
            this.speed = speed;            // Rychlost "Chůze"
        }

        /// <summary>
        /// Vykreslení nepřítele
        /// </summary>
        /// <param name="spriteBatch">Třída pro práci se sprity</param>
        /// <param name="sprEnemyShip">Sprit nepřítelovi lodi</param>
        public void DrawEnemy(SpriteBatch spriteBatch, Texture2D sprEnemyShip)
        {
            spriteBatch.Draw(sprEnemyShip, position, Color.White);
        }

        /// <summary>
        /// Let lodi
        /// <param name="widthSpr">Šířka nepřítele</param>
        /// <param name="heightSpr">Výška nepřítele</param>
        /// <param name="heightSpr">Hráč</param>
        public void ControlEnemy(int widthSpr, int heightSpr, Player player)
        {
            position.Y += speed;
            enemyRec = new Rectangle((int)position.X, (int)position.Y, widthSpr, heightSpr);    // Ohraničení nepřítele
        }

        /// <summary>
        /// Kontroluje jestli loď nevyjela z mapy
        /// </summary>
        /// <param name="heightMap">Výška herní mapy</param>
        /// <param name="heightInfoBar">Výška informativního panelu hráče</param>
        /// <returns>Vyjel / Nevyjel z herní mapy</returns>
        public bool IsBehindMap(int heightMap, int heightInfoBar)
        {
            bool isTrue = false;

            if (position.Y > (heightMap - heightInfoBar))
                isTrue = true;

            return isTrue;
        }
    }
}
